local
  open Mixture Const Lambda Asynt;
in

type RenEnv = (string * int) list;
val lookupRenEnv : QualifiedIdent -> (QualifiedIdent * int);
val updateCurrentRenEnv: RenEnv -> unit;

val renameId : string -> string * int;

datatype AccessPath =
    Path_local of int
  | Path_global of (QualifiedIdent * int)
  | Path_son of int * AccessPath
  | Path_virtual_son of int * AccessPath
;

type TranslEnv = (string, AccessPath) Env * int;

val translateLocalAccess : TranslEnv -> string -> Lambda;
val translateAccess : TranslEnv -> QualifiedIdent -> Lambda;
val translateExName : TranslEnv -> IdInfo -> Lambda;
val mkEnvOfRecPats : int -> Pat list -> TranslEnv;
val mkEnvOfPats : int -> Pat list -> TranslEnv * (Lambda -> Lambda);

end;
